part of viltage;

class State {
  List<CharNode> charNodes = new List<CharNode>();
  
  render(int x, int y, List<List<CharNode>> charArray) {
    for(int i = 0; i < charNodes.length; i++) {
      if(y+charNodes[i].y < charArray.length && y+charNodes[i].y >= 0 &&
         x+charNodes[i].x < charArray[0].length  && x+charNodes[i].x >= 0
         && charNodes[i].visible) {
        charArray[y+charNodes[i].y][x+charNodes[i].x] = charNodes[i];
      }
    }
  }
  
  CharNode createCharNode(int x, int y, String text) {
    CharNode cn;
    cn = new CharNode(x, y, text);
    charNodes.add(cn);
    return cn;
  }
  
  List<CharNode> createCharNodeLine(int x, int y, bool horizontal, String text) {
    List<CharNode> charNodes = new List<CharNode>();
    for(int i = 0; i < text.length; i++) {
      if(horizontal) charNodes.add(createCharNode(x + i, y, text[i]));
      else charNodes.add(createCharNode(x, y + i, text[i]));
    }
    return charNodes;
  }
  
  List<List<CharNode>> createCharNodeRect(int x, int y, List<String> text) {
    List<List<CharNode>> charNodes = new List<List<CharNode>>();
    for(int i = 0; i < text.length; i++) {
      charNodes.add(createCharNodeLine(x, y+i, true, text[i]));
    }
    return charNodes;
  }
}